
function init()
    body = FindBody("bombardball")
    radius = 1.0

    trigger1 = false
    trigger2 = false
end

function tick(dt)
    local vel = GetBodyVelocity(body)
    sparks(GetBodyTransform(body).pos)
    if VecLength(vel) > 30 then
        trigger1 = true
    end
    if trigger1 then
        QueryRejectBody(body)
        --local hit, point, normal, shape = QueryClosestPoint(GetBodyTransform(body).pos, radius)
        local hit = VecLength(vel) <= 10
        if trigger2 and hit then
            Explosion(GetBodyTransform(body).pos, 2)
            Delete(body)
            trigger1 = false
        elseif trigger1 and not hit then
            trigger2 = true
        end
    end
end

function randVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function randFloat(mi, ma)
	return math.random(1000)/1000*(ma-mi) + mi
end

function sparks(pos)
	local radius = 0.25
	local life = 1.2
	local count = 1
	local drag = 0.2
	local gravity = 0.5
	local alpha = 0.6

    local chances = 0
    if VecLength(GetBodyVelocity(body)) > 30 then
        chances = 7
        life = life / 2
    elseif VecLength(GetBodyVelocity(body)) < 1 then
        chances = -1
        life = life / 2
    end
    if math.random(1, 10) <= 8 - chances then
        return
    end
	
	--Set up the particle state
	ParticleReset()
	ParticleType("plain")
	ParticleRadius(radius)
	ParticleAlpha(alpha, 0.2)	-- Ramp up fast, ramp down after 50%
	ParticleGravity(gravity * randFloat(0.7, 1.3))				-- Slightly randomized gravity looks better
	ParticleDrag(drag)
	ParticleTile(5)
	ParticleCollide(0, 1, "easeout")
    ParticleEmissive(0.8, 0.8)
	
	--Emit particles
	for i=1, count do
        local red = 0.1
        local green = 0.1
        local blue = 0.1
        ParticleColor(red, green, blue, 0, 0, 0)			-- Animating color towards white
		local p = TransformToParentPoint(GetBodyTransform(body), Vec(0.05, 0, -0.1))--VecAdd(pos, randVec(radius))
		local v = Vec()--VecScale(GetBodyVelocity(body), -1)
	
		--Randomize lifetime
		local l = randFloat(life * 0.8, life * 1.2)

		SpawnParticle(p, v, l)
	end
end
